﻿Type=Service
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private serial As Serial
	Private admin As BluetoothAdmin
	Private astream As AsyncStreams
	Public connected As Boolean
	Public connecting As Boolean
	Private ser As B4RSerializator
End Sub

Sub Service_Create
	serial.Initialize("serial")
	admin.Initialize("admin")
	ser.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)
' NO ACTION
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	' NO ACTION
End Sub

Public Sub Connect
	admin.StartDiscovery
	connecting = True
	CallSub(Main, "SetState")
End Sub

Private Sub admin_DeviceFound (Name As String, MacAddress As String)
	Log($"Device found: ${Name}"$)
	If Name = "HC-05" Then
		Log("Trying to connect...")
		admin.CancelDiscovery
		serial.Connect(MacAddress)
	End If
End Sub

Private Sub admin_DiscoveryFinished
	connecting = False
End Sub

Private Sub Serial_Connected (Success As Boolean)
	If Success Then
		If astream.IsInitialized Then astream.Close
		astream.Initialize(serial.InputStream, serial.OutputStream,"astream")
		Log("Connected")
		connected = True
	Else
		Log(LastException)
	End If
	connecting = False
	CallSub(Main, "SetState")
End Sub

Public Sub SendMessage(msg() As Byte)
	Log("SendMessage")
	astream.Write(ser.ConvertArrayToBytes(Array(msg)))
End Sub

Private Sub astream_NewData (Buffer() As Byte)
	CallSub2(Main, "NewValue", ser.ConvertBytesToArray(Buffer))
End Sub

Private Sub astream_Error
	connected = False
	CallSub(Main, "SetState")
End Sub

Private Sub astream_Terminated
	astream_Error
End Sub

